本文中用C#来操作Word,包括:
创建Word;
插入文字,选择文字,编辑文字的字号、粗细、颜色、下划线等;
设置段落的首行缩进、行距;
设置页面页边距和纸张大小;
设置页眉、页码;
插入图片,设置图片宽高以及给图片添加标题;
插入表格,格式化表格,往表格中插入数据;
保存Word,打印Word;
重新打开Word等。
Visual studio版本:Visual Studio 2012(2010应该也可以)
准备工作:
/*
1. 添加引用COM里面的 Microsoft Word 12.0 Object. Library 引用(12.0表示Word 2007版本)
2. 导命名空间
using MSWord =Microsoft.Office.Interop.Word;
using System.IO;
using System.Reflection;
3. 把引用中的Microsoft.Office.Interop.Word的“属性”中的嵌入互操作设为False
*/
以下是全部代码:(代码有点长,但请不要有压力,直接复制进去就能直接成功运行)
1 using System; 2 using System.Collections.Generic; 3 using System.Linq; 4 using System.Runtime.InteropServices; 5 using System.Text; 6 using MSWord = Microsoft.Office.Interop.Word; 7 using System.IO; 8 using System.Reflection; 9 10 namespace Console_WordSkill_All 11 { 12 class Program 13 { 14 static void Main(string[] args) 15 { 16 object path; //文件路径变量 17 string strContent; //文本内容变量 18 MSWord.Application wordApp; //Word应用程序变量 19 MSWord.Document wordDoc; //Word文档变量 20 21 path = Environment.CurrentDirectory + "\\MyWord_Print.doc"; 22 wordApp = new MSWord.ApplicationClass(); //初始化 23 24 wordApp.Visible = true;//使文档可见 25 26 //如果已存在,则删除 27 if (File.Exists((string)path)) 28 { 29 File.Delete((string)path); 30 } 31 32 //由于使用的是COM库,因此有许多变量需要用Missing.Value代替 33 Object Nothing = Missing.Value; 34 wordDoc = wordApp.Documents.Add(ref Nothing, ref Nothing, ref Nothing, ref Nothing); 35 36 #region 页面设置、页眉图片和文字设置,最后跳出页眉设置 37 38 //页面设置 39 wordDoc.PageSetup.PaperSize = MSWord.WdPaperSize.wdPaperA4;//设置纸张样式为A4纸 40 wordDoc.PageSetup.Orientation = MSWord.WdOrientation.wdOrientPortrait;//排列方式为垂直方向 41 wordDoc.PageSetup.TopMargin = 57.0f; 42 wordDoc.PageSetup.BottomMargin = 57.0f; 43 wordDoc.PageSetup.LeftMargin = 57.0f; 44 wordDoc.PageSetup.RightMargin = 57.0f; 45 wordDoc.PageSetup.HeaderDistance = 30.0f;//页眉位置 46 47 //设置页眉 48 wordApp.ActiveWindow.View.Type = MSWord.WdViewType.wdNormalView;//普通视图(即页面视图)样式 49 wordApp.ActiveWindow.View.SeekView = MSWord.WdSeekView.wdSeekPrimaryHeader;//进入页眉设置,其中页眉边距在页面设置中已完成 50 wordApp.Selection.ParagraphFormat.Alignment = MSWord.WdParagraphAlignment.wdAlignParagraphRight;//页眉中的文字右对齐 51 52 53 //插入页眉图片(测试结果图片未插入成功) 54 wordApp.Selection.ParagraphFormat.Alignment = MSWord.WdParagraphAlignment.wdAlignParagraphCenter; 55 string headerfile = @"C:\Users\xiahui\Desktop\OficeProgram\3.jpg"; 56 MSWord.InlineShape shape1 = wordApp.ActiveWindow.ActivePane.Selection.InlineShapes.AddPicture(headerfile, ref Nothing, ref Nothing, ref Nothing); 57 shape1.Height = 5;//强行设置貌似无效,图片没有按设置的缩放——图片的比例并没有改变。 58 shape1.Width = 20; 59 wordApp.ActiveWindow.ActivePane.Selection.InsertAfter(" 文档页眉");//在页眉的图片后面追加几个字 60 61 //去掉页眉的横线 62 wordApp.ActiveWindow.ActivePane.Selection.ParagraphFormat.Borders[MSWord.WdBorderType.wdBorderBottom].LineStyle = MSWord.WdLineStyle.wdLineStyleNone; 63 wordApp.ActiveWindow.ActivePane.Selection.Borders[MSWord.WdBorderType.wdBorderBottom].Visible = false; 64 wordApp.ActiveWindow.ActivePane.View.SeekView = MSWord.WdSeekView.wdSeekMainDocument;//退出页眉设置 65 #endregion 66 67 #region 页码设置并添加页码 68 69 //为当前页添加页码 70 MSWord.PageNumbers pns = wordApp.Selection.Sections[1].Headers[MSWord.WdHeaderFooterIndex.wdHeaderFooterEvenPages].PageNumbers;//获取当前页的号码 71 pns.NumberStyle = MSWord.WdPageNumberStyle.wdPageNumberStyleNumberInDash;//设置页码的风格,是Dash形还是圆形的 72 pns.HeadingLevelForChapter = 0; 73 pns.IncludeChapterNumber = false; 74 pns.RestartNumberingAtSection = false; 75 pns.StartingNumber = 0; //开始页页码? 76 object pagenmbetal = MSWord.WdPageNumberAlignment.wdAlignPageNumberCenter;//将号码设置在中间 77 object first = true; 78 wordApp.Selection.Sections[1].Footers[MSWord.WdHeaderFooterIndex.wdHeaderFooterEvenPages].PageNumbers.Add(ref pagenmbetal, ref first); 79 80 #endregion 81 82 #region 行间距与缩进、文本字体、字号、加粗、斜体、颜色、下划线、下划线颜色设置 83 84 wordApp.Selection.ParagraphFormat.LineSpacing = 16f;//设置文档的行间距 85 wordApp.Selection.ParagraphFormat.FirstLineIndent = 30;//首行缩进的长度 86 //写入普通文本 87 strContent = "我是普通文本\n"; 88 wordDoc.Paragraphs.Last.Range.Text = strContent; 89 90 wordDoc.Paragraphs.Last.Range.Text = "我再加一行试试,这里不加'\\n'"; 91 //直接添加段,不是覆盖( += ) 92 wordDoc.Paragraphs.Last.Range.Text += "不会覆盖的,"; 93 94 //添加在此段的文字后面,不是新段落 95 wordDoc.Paragraphs.Last.Range.InsertAfter("这是后面的内容\n"); 96 97 //将文档的前4个字替换成"哥是替换文字",并将其颜色设为红色 98 object start = 0; 99 object end = 4; 100 MSWord.Range rang = wordDoc.Range(ref start, ref end); 101 rang.Font.Color = MSWord.WdColor.wdColorRed; 102 rang.Text = "哥是替换文字"; 103 wordDoc.Range(ref start, ref end); 104 105 //写入黑体文本 106 object unite = MSWord.WdUnits.wdStory; 107 wordApp.Selection.EndKey(ref unite, ref Nothing);//将光标移到文本末尾 108 wordApp.Selection.ParagraphFormat.FirstLineIndent = 0;//取消首行缩进的长度 109 strContent = "这是黑体文本\n"; 110 wordDoc.Paragraphs.Last.Range.Font.Name = "黑体"; 111 wordDoc.Paragraphs.Last.Range.Text = strContent; 112 113 //写入加粗文本 114 strContent = "这是粗体文本\n"; // 115 wordApp.Selection.EndKey(ref unite, ref Nothing);//这一句不加,有时候好像也不出问题,不过还是加了安全 116 wordDoc.Paragraphs.Last.Range.Font.Bold = 1; 117 wordDoc.Paragraphs.Last.Range.Text = strContent; 118 119 //写入15号字体文本 120 strContent = "我这个文本的字号是15号,而且是宋体\n"; 121 wordApp.Selection.EndKey(ref unite, ref Nothing); 122 wordDoc.Paragraphs.Last.Range.Font.Size = 15; 123 wordDoc.Paragraphs.Last.Range.Font.Name = "宋体"; 124 wordDoc.Paragraphs.Last.Range.Text = strContent; 125 126 //写入斜体文本 127 strContent = "我是斜体字文本\n"; 128 wordApp.Selection.EndKey(ref unite, ref Nothing); 129 wordDoc.Paragraphs.Last.Range.Font.Italic = 1; 130 wordDoc.Paragraphs.Last.Range.Text = strContent; 131 132 //写入蓝色文本 133 strContent = "我是蓝色的文本\n"; 134 wordApp.Selection.EndKey(ref unite, ref Nothing); 135 wordDoc.Paragraphs.Last.Range.Font.Color = MSWord.WdColor.wdColorBlue; 136 wordDoc.Paragraphs.Last.Range.Text = strContent; 137 138 //写入下划线文本 139 strContent = "我是下划线文本\n"; 140 wordApp.Selection.EndKey(ref unite, ref Nothing); 141 wordDoc.Paragraphs.Last.Range.Font.Underline = MSWord.WdUnderline.wdUnderlineThick; 142 wordDoc.Paragraphs.Last.Range.Text = strContent; 143 144 //写入红色下画线文本 145 strContent = "我是点线下划线,并且下划线是红色的\n"; 146 wordApp.Selection.EndKey(ref unite, ref Nothing); 147 wordDoc.Paragraphs.Last.Range.Font.Underline = MSWord.WdUnderline.wdUnderlineDottedHeavy; 148 wordDoc.Paragraphs.Last.Range.Font.UnderlineColor = MSWord.WdColor.wdColorRed; 149 wordDoc.Paragraphs.Last.Range.Text = strContent; 150 151 //取消下划线,并且将字号调整为12号 152 strContent = "我他妈不要下划线了,并且设置字号为12号,黑色不要斜体\n"; 153 wordApp.Selection.EndKey(ref unite, ref Nothing); 154 wordDoc.Paragraphs.Last.Range.Font.Size = 12; 155 wordDoc.Paragraphs.Last.Range.Font.Underline = MSWord.WdUnderline.wdUnderlineNone; 156 wordDoc.Paragraphs.Last.Range.Font.Color = MSWord.WdColor.wdColorBlack; 157 wordDoc.Paragraphs.Last.Range.Font.Italic = 0; 158 wordDoc.Paragraphs.Last.Range.Text = strContent; 159 160 161 #endregion 162 163 164 #region 插入图片、居中显示,设置图片的绝对尺寸和缩放尺寸,并给图片添加标题 165 166 wordApp.Selection.EndKey(ref unite, ref Nothing); //将光标移动到文档末尾 167 //图片文件的路径 168 string filename = Environment.CurrentDirectory + "\\6.jpg"; 169 //要向Word文档中插入图片的位置 170 Object range = wordDoc.Paragraphs.Last.Range; 171 //定义该插入的图片是否为外部链接 172 Object linkToFile = false; //默认,这里貌似设置为bool类型更清晰一些 173 //定义要插入的图片是否随Word文档一起保存 174 Object saveWithDocument = true; //默认 175 //使用InlineShapes.AddPicture方法(【即“嵌入型”】)插入图片 176 wordDoc.InlineShapes.AddPicture(filename, ref linkToFile, ref saveWithDocument, ref range); 177 wordApp.Selection.ParagraphFormat.Alignment = MSWord.WdParagraphAlignment.wdAlignParagraphCenter;//居中显示图片 178 179 //设置图片宽高的绝对大小 180 181 //wordDoc.InlineShapes[1].Width = 200; 182 //wordDoc.InlineShapes[1].Height = 150; 183 //按比例缩放大小 184 185 wordDoc.InlineShapes[1].ScaleWidth = 20;//缩小到20% ? 186 wordDoc.InlineShapes[1].ScaleHeight = 20; 187 188 //在图下方居中添加图片标题 189 190 wordDoc.Content.InsertAfter("\n");//这一句与下一句的顺序不能颠倒,原因还没搞透 191 wordApp.Selection.EndKey(ref unite, ref Nothing); 192 wordApp.Selection.ParagraphFormat.Alignment = MSWord.WdParagraphAlignment.wdAlignParagraphCenter; 193 wordApp.Selection.Font.Size = 10;//字体大小 194 wordApp.Selection.TypeText("图1 测试图片\n"); 195 196 #endregion 197 198 #region 添加表格、填充数据、设置表格行列宽高、合并单元格、添加表头斜线、给单元格添加图片 199 wordDoc.Content.InsertAfter("\n");//这一句与下一句的顺序不能颠倒,原因还没搞透 200 wordApp.Selection.EndKey(ref unite, ref Nothing); //将光标移动到文档末尾 201 wordApp.Selection.ParagraphFormat.Alignment = MSWord.WdParagraphAlignment.wdAlignParagraphLeft; 202 //object WdLine2 = MSWord.WdUnits.wdLine;//换一行; 203 //wordApp.Selection.MoveDown(ref WdLine2, 6, ref Nothing);//向下跨15行输入表格,这样表格就在文字下方了,不过这是非主流的方法 204 205 //设置表格的行数和列数 206 int tableRow = 6; 207 int tableColumn = 6; 208 209 //定义一个Word中的表格对象 210 MSWord.Table table = wordDoc.Tables.Add(wordApp.Selection.Range, 211 tableRow, tableColumn, ref Nothing, ref Nothing); 212 213 //默认创建的表格没有边框,这里修改其属性,使得创建的表格带有边框 214 table.Borders.Enable = 1;//这个值可以设置得很大,例如5、13等等 215 216 //表格的索引是从1开始的。 217 wordDoc.Tables[1].Cell(1, 1).Range.Text = "列\n行"; 218 for (int i = 1; i < tableRow; i++) 219 { 220 for (int j = 1; j < tableColumn; j++) 221 { 222 if (i == 1) 223 { 224 table.Cell(i, j + 1).Range.Text = "Column " + j;//填充每列的标题 225 } 226 if (j == 1) 227 { 228 table.Cell(i + 1, j).Range.Text = "Row " + i; //填充每行的标题 229 } 230 table.Cell(i + 1, j + 1).Range.Text = i + "行 " + j + "列"; //填充表格的各个小格子 231 } 232 } 233 234 235 //添加行 236 table.Rows.Add(ref Nothing); 237 table.Rows[tableRow + 1].Height = 35;//设置新增加的这行表格的高度 238 //向新添加的行的单元格中添加图片 239 string FileName = Environment.CurrentDirectory + "\\6.jpg";//图片所在路径 240 object LinkToFile = false; 241 object SaveWithDocument = true; 242 object Anchor = table.Cell(tableRow + 1, tableColumn).Range;//选中要添加图片的单元格 243 wordDoc.Application.ActiveDocument.InlineShapes.AddPicture(FileName, ref LinkToFile, ref SaveWithDocument, ref Anchor); 244 245 //由于是本文档的第2张图,所以这里是InlineShapes[2] 246 wordDoc.Application.ActiveDocument.InlineShapes[2].Width = 50;//图片宽度 247 wordDoc.Application.ActiveDocument.InlineShapes[2].Height = 35;//图片高度 248 249 // 将图片设置为四周环绕型 250 MSWord.Shape s = wordDoc.Application.ActiveDocument.InlineShapes[2].ConvertToShape(); 251 s.WrapFormat.Type = MSWord.WdWrapType.wdWrapSquare; 252 253 254 //设置table样式 255 table.Rows.HeightRule = MSWord.WdRowHeightRule.wdRowHeightAtLeast;//高度规则是:行高有最低值下限? 256 table.Rows.Height = wordApp.CentimetersToPoints(float.Parse("0.8"));// 257 258 table.Range.Font.Size = 10.5F; 259 table.Range.Font.Bold = 0; 260 261 table.Range.ParagraphFormat.Alignment = MSWord.WdParagraphAlignment.wdAlignParagraphCenter;//表格文本居中 262 table.Range.Cells.VerticalAlignment = MSWord.WdCellVerticalAlignment.wdCellAlignVerticalBottom;//文本垂直贴到底部 263 //设置table边框样式 264 table.Borders.OutsideLineStyle = MSWord.WdLineStyle.wdLineStyleDouble;//表格外框是双线 265 table.Borders.InsideLineStyle = MSWord.WdLineStyle.wdLineStyleSingle;//表格内框是单线 266 267 table.Rows[1].Range.Font.Bold = 1;//加粗 268 table.Rows[1].Range.Font.Size = 12F; 269 table.Cell(1, 1).Range.Font.Size = 10.5F; 270 wordApp.Selection.Cells.Height = 30;//所有单元格的高度 271 272 //除第一行外,其他行的行高都设置为20 273 for (int i = 2; i <= tableRow; i++) 274 { 275 table.Rows[i].Height = 20; 276 } 277 278 //将表格左上角的单元格里的文字(“行” 和 “列”)居右 279 table.Cell(1, 1).Range.ParagraphFormat.Alignment = MSWord.WdParagraphAlignment.wdAlignParagraphRight; 280 //将表格左上角的单元格里面下面的“列”字移到左边,相比上一行就是将ParagraphFormat改成了Paragraphs[2].Format 281 table.Cell(1, 1).Range.Paragraphs[2].Format.Alignment = MSWord.WdParagraphAlignment.wdAlignParagraphLeft; 282 283 table.Columns[1].Width = 50;//将第 1列宽度设置为50 284 285 //将其他列的宽度都设置为75 286 for (int i = 2; i <= tableColumn; i++) 287 { 288 table.Columns[i].Width = 75; 289 } 290 291 292 //添加表头斜线,并设置表头的样式 293 table.Cell(1, 1).Borders[MSWord.WdBorderType.wdBorderDiagonalDown].Visible = true; 294 table.Cell(1, 1).Borders[MSWord.WdBorderType.wdBorderDiagonalDown].Color = MSWord.WdColor.wdColorRed; 295 table.Cell(1, 1).Borders[MSWord.WdBorderType.wdBorderDiagonalDown].LineWidth = MSWord.WdLineWidth.wdLineWidth150pt; 296 297 //合并单元格 298 table.Cell(4, 4).Merge(table.Cell(4, 5));//横向合并 299 300 table.Cell(2, 3).Merge(table.Cell(4, 3));//纵向合并,合并(2,3),(3,3),(4,3) 301 302 #endregion 303 304 wordApp.Selection.EndKey(ref unite, ref Nothing); //将光标移动到文档末尾 305 306 wordDoc.Content.InsertAfter("\n"); 307 wordDoc.Content.InsertAfter("就写这么多,算了吧!2016.09.27"); 308 309 310 311 //WdSaveFormat为Word 2003文档的保存格式 312 object format = MSWord.WdSaveFormat.wdFormatDocument;// office 2007就是wdFormatDocumentDefault 313 //将wordDoc文档对象的内容保存为DOCX文档 314 wordDoc.SaveAs(ref path, ref format, ref Nothing, ref Nothing, ref Nothing, ref Nothing, ref Nothing, ref Nothing, ref Nothing, ref Nothing, ref Nothing, ref Nothing, ref Nothing, ref Nothing, ref Nothing, ref Nothing); 315 //关闭wordDoc文档对象 316 317 //看是不是要打印 318 //wordDoc.PrintOut(); 319 320 321 322 wordDoc.Close(ref Nothing, ref Nothing, ref Nothing); 323 //关闭wordApp组件对象 324 wordApp.Quit(ref Nothing, ref Nothing, ref Nothing); 325 Console.WriteLine(path + " 创建完毕!"); 326 Console.ReadKey(); 327 328 329 //我还要打开这个文档玩玩 330 MSWord.Application app = new MSWord.Application(); 331 MSWord.Document doc = null; 332 try 333 { 334 335 object unknow = Type.Missing; 336 app.Visible = true; 337 string str = Environment.CurrentDirectory + "\\MyWord_Print.doc"; 338 object file = str; 339 doc = app.Documents.Open(ref file, 340 ref unknow, ref unknow, ref unknow, ref unknow, 341 ref unknow, ref unknow, ref unknow, ref unknow, 342 ref unknow, ref unknow, ref unknow, ref unknow, 343 ref unknow, ref unknow, ref unknow); 344 string temp = doc.Paragraphs[1].Range.Text.Trim(); 345 Console.WriteLine("你他妈输出temp干嘛?"); 346 } 347 catch (Exception ex) 348 { 349 Console.WriteLine(ex.Message); 350 } 351 wordDoc = doc; 352 wordDoc.Paragraphs.Last.Range.Text += "我真的不打算再写了,就写这么多吧"; 353 354 Console.ReadKey(); 355 } 356 357 } 358 }
生成编辑的Word内容如下图所示:
本文中用C#来操作Word,包括:
创建Word;
插入文字,选择文字,编辑文字的字号、粗细、颜色、下划线等;
设置段落的首行缩进、行距;
设置页面页边距和纸张大小;
设置页眉、页码;
插入图片,设置图片宽高以及给图片添加标题;
插入表格,格式化表格,往表格中插入数据;
保存Word,打印Word;
重新打开Word等。
Visual studio版本:Visual Studio 2012(2010应该也可以)
准备工作:
/*
1. 添加引用COM里面的 Microsoft Word 12.0 Object. Library 引用(12.0表示Word 2007版本)
2. 导命名空间
using MSWord =Microsoft.Office.Interop.Word;
using System.IO;
using System.Reflection;
3. 把引用中的Microsoft.Office.Interop.Word的“属性”中的嵌入互操作设为False
*/
以下是全部代码:(代码有点长,但请不要有压力,直接复制进去就能直接成功运行)
复制代码
1 using System;
2 using System.Collections.Generic;
3 using System.Linq;
4 using System.Runtime.InteropServices;
5 using System.Text;
6 using MSWord = Microsoft.Office.Interop.Word;
7 using System.IO;
8 using System.Reflection;
9
10 namespace Console_WordSkill_All
11 {
12 class Program
13 {
14 static void Main(string[] args)
15 {
16 object path; //文件路径变量
17 string strContent; //文本内容变量
18 MSWord.Application wordApp; //Word应用程序变量
19 MSWord.Document wordDoc; //Word文档变量
20
21 path = Environment.CurrentDirectory + "\\MyWord_Print.doc";
22 wordApp = new MSWord.ApplicationClass(); //初始化
23
24 wordApp.Visible = true;//使文档可见
25
26 //如果已存在,则删除
27 if (File.Exists((string)path))
28 {
29 File.Delete((string)path);
30 }
31
32 //由于使用的是COM库,因此有许多变量需要用Missing.Value代替
33 Object Nothing = Missing.Value;
34 wordDoc = wordApp.Documents.Add(ref Nothing, ref Nothing, ref Nothing, ref Nothing);
35
36 #region 页面设置、页眉图片和文字设置,最后跳出页眉设置
37
38 //页面设置
39 wordDoc.PageSetup.PaperSize = MSWord.WdPaperSize.wdPaperA4;//设置纸张样式为A4纸
40 wordDoc.PageSetup.Orientation = MSWord.WdOrientation.wdOrientPortrait;//排列方式为垂直方向
41 wordDoc.PageSetup.TopMargin = 57.0f;
42 wordDoc.PageSetup.BottomMargin = 57.0f;
43 wordDoc.PageSetup.LeftMargin = 57.0f;
44 wordDoc.PageSetup.RightMargin = 57.0f;
45 wordDoc.PageSetup.HeaderDistance = 30.0f;//页眉位置
46
47 //设置页眉
48 wordApp.ActiveWindow.View.Type = MSWord.WdViewType.wdNormalView;//普通视图(即页面视图)样式
49 wordApp.ActiveWindow.View.SeekView = MSWord.WdSeekView.wdSeekPrimaryHeader;//进入页眉设置,其中页眉边距在页面设置中已完成
50 wordApp.Selection.ParagraphFormat.Alignment = MSWord.WdParagraphAlignment.wdAlignParagraphRight;//页眉中的文字右对齐
51
52
53 //插入页眉图片(测试结果图片未插入成功)
54 wordApp.Selection.ParagraphFormat.Alignment = MSWord.WdParagraphAlignment.wdAlignParagraphCenter;
55 string headerfile = @"C:\Users\xiahui\Desktop\OficeProgram\3.jpg";
56 MSWord.InlineShape shape1 = wordApp.ActiveWindow.ActivePane.Selection.InlineShapes.AddPicture(headerfile, ref Nothing, ref Nothing, ref Nothing);
57 shape1.Height = 5;//强行设置貌似无效,图片没有按设置的缩放——图片的比例并没有改变。
58 shape1.Width = 20;
59 wordApp.ActiveWindow.ActivePane.Selection.InsertAfter(" 文档页眉");//在页眉的图片后面追加几个字
60
61 //去掉页眉的横线
62 wordApp.ActiveWindow.ActivePane.Selection.ParagraphFormat.Borders[MSWord.WdBorderType.wdBorderBottom].LineStyle = MSWord.WdLineStyle.wdLineStyleNone;
63 wordApp.ActiveWindow.ActivePane.Selection.Borders[MSWord.WdBorderType.wdBorderBottom].Visible = false;
64 wordApp.ActiveWindow.ActivePane.View.SeekView = MSWord.WdSeekView.wdSeekMainDocument;//退出页眉设置
65 #endregion
66
67 #region 页码设置并添加页码
68
69 //为当前页添加页码
70 MSWord.PageNumbers pns = wordApp.Selection.Sections[1].Headers[MSWord.WdHeaderFooterIndex.wdHeaderFooterEvenPages].PageNumbers;//获取当前页的号码
71 pns.NumberStyle = MSWord.WdPageNumberStyle.wdPageNumberStyleNumberInDash;//设置页码的风格,是Dash形还是圆形的
72 pns.HeadingLevelForChapter = 0;
73 pns.IncludeChapterNumber = false;
74 pns.RestartNumberingAtSection = false;
75 pns.StartingNumber = 0; //开始页页码?
76 object pagenmbetal = MSWord.WdPageNumberAlignment.wdAlignPageNumberCenter;//将号码设置在中间
77 object first = true;
78 wordApp.Selection.Sections[1].Footers[MSWord.WdHeaderFooterIndex.wdHeaderFooterEvenPages].PageNumbers.Add(ref pagenmbetal, ref first);
79
80 #endregion
81
82 #region 行间距与缩进、文本字体、字号、加粗、斜体、颜色、下划线、下划线颜色设置
83
84 wordApp.Selection.ParagraphFormat.LineSpacing = 16f;//设置文档的行间距
85 wordApp.Selection.ParagraphFormat.FirstLineIndent = 30;//首行缩进的长度
86 //写入普通文本
87 strContent = "我是普通文本\n";
88 wordDoc.Paragraphs.Last.Range.Text = strContent;
89
90 wordDoc.Paragraphs.Last.Range.Text = "我再加一行试试,这里不加'\\n'";
91 //直接添加段,不是覆盖( += )
92 wordDoc.Paragraphs.Last.Range.Text += "不会覆盖的,";
93
94 //添加在此段的文字后面,不是新段落
95 wordDoc.Paragraphs.Last.Range.InsertAfter("这是后面的内容\n");
96
97 //将文档的前4个字替换成"哥是替换文字",并将其颜色设为红色
98 object start = 0;
99 object end = 4;
100 MSWord.Range rang = wordDoc.Range(ref start, ref end);
101 rang.Font.Color = MSWord.WdColor.wdColorRed;
102 rang.Text = "哥是替换文字";
103 wordDoc.Range(ref start, ref end);
104
105 //写入黑体文本
106 object unite = MSWord.WdUnits.wdStory;
107 wordApp.Selection.EndKey(ref unite, ref Nothing);//将光标移到文本末尾
108 wordApp.Selection.ParagraphFormat.FirstLineIndent = 0;//取消首行缩进的长度
109 strContent = "这是黑体文本\n";
110 wordDoc.Paragraphs.Last.Range.Font.Name = "黑体";
111 wordDoc.Paragraphs.Last.Range.Text = strContent;
112
113 //写入加粗文本
114 strContent = "这是粗体文本\n"; //
115 wordApp.Selection.EndKey(ref unite, ref Nothing);//这一句不加,有时候好像也不出问题,不过还是加了安全
116 wordDoc.Paragraphs.Last.Range.Font.Bold = 1;
117 wordDoc.Paragraphs.Last.Range.Text = strContent;
118
119 //写入15号字体文本
120 strContent = "我这个文本的字号是15号,而且是宋体\n";
121 wordApp.Selection.EndKey(ref unite, ref Nothing);
122 wordDoc.Paragraphs.Last.Range.Font.Size = 15;
123 wordDoc.Paragraphs.Last.Range.Font.Name = "宋体";
124 wordDoc.Paragraphs.Last.Range.Text = strContent;
125
126 //写入斜体文本
127 strContent = "我是斜体字文本\n";
128 wordApp.Selection.EndKey(ref unite, ref Nothing);
129 wordDoc.Paragraphs.Last.Range.Font.Italic = 1;
130 wordDoc.Paragraphs.Last.Range.Text = strContent;
131
132 //写入蓝色文本
133 strContent = "我是蓝色的文本\n";
134 wordApp.Selection.EndKey(ref unite, ref Nothing);
135 wordDoc.Paragraphs.Last.Range.Font.Color = MSWord.WdColor.wdColorBlue;
136 wordDoc.Paragraphs.Last.Range.Text = strContent;
137
138 //写入下划线文本
139 strContent = "我是下划线文本\n";
140 wordApp.Selection.EndKey(ref unite, ref Nothing);
141 wordDoc.Paragraphs.Last.Range.Font.Underline = MSWord.WdUnderline.wdUnderlineThick;
142 wordDoc.Paragraphs.Last.Range.Text = strContent;
143
144 //写入红色下画线文本
145 strContent = "我是点线下划线,并且下划线是红色的\n";
146 wordApp.Selection.EndKey(ref unite, ref Nothing);
147 wordDoc.Paragraphs.Last.Range.Font.Underline = MSWord.WdUnderline.wdUnderlineDottedHeavy;
148 wordDoc.Paragraphs.Last.Range.Font.UnderlineColor = MSWord.WdColor.wdColorRed;
149 wordDoc.Paragraphs.Last.Range.Text = strContent;
150
151 //取消下划线,并且将字号调整为12号
152 strContent = "我他妈不要下划线了,并且设置字号为12号,黑色不要斜体\n";
153 wordApp.Selection.EndKey(ref unite, ref Nothing);
154 wordDoc.Paragraphs.Last.Range.Font.Size = 12;
155 wordDoc.Paragraphs.Last.Range.Font.Underline = MSWord.WdUnderline.wdUnderlineNone;
156 wordDoc.Paragraphs.Last.Range.Font.Color = MSWord.WdColor.wdColorBlack;
157 wordDoc.Paragraphs.Last.Range.Font.Italic = 0;
158 wordDoc.Paragraphs.Last.Range.Text = strContent;
159
160
161 #endregion
162
163
164 #region 插入图片、居中显示,设置图片的绝对尺寸和缩放尺寸,并给图片添加标题
165
166 wordApp.Selection.EndKey(ref unite, ref Nothing); //将光标移动到文档末尾
167 //图片文件的路径
168 string filename = Environment.CurrentDirectory + "\\6.jpg";
169 //要向Word文档中插入图片的位置
170 Object range = wordDoc.Paragraphs.Last.Range;
171 //定义该插入的图片是否为外部链接
172 Object linkToFile = false; //默认,这里貌似设置为bool类型更清晰一些
173 //定义要插入的图片是否随Word文档一起保存
174 Object saveWithDocument = true; //默认
175 //使用InlineShapes.AddPicture方法(【即“嵌入型”】)插入图片
176 wordDoc.InlineShapes.AddPicture(filename, ref linkToFile, ref saveWithDocument, ref range);
177 wordApp.Selection.ParagraphFormat.Alignment = MSWord.WdParagraphAlignment.wdAlignParagraphCenter;//居中显示图片
178
179 //设置图片宽高的绝对大小
180
181 //wordDoc.InlineShapes[1].Width = 200;
182 //wordDoc.InlineShapes[1].Height = 150;
183 //按比例缩放大小
184
185 wordDoc.InlineShapes[1].ScaleWidth = 20;//缩小到20% ?
186 wordDoc.InlineShapes[1].ScaleHeight = 20;
187
188 //在图下方居中添加图片标题
189
190 wordDoc.Content.InsertAfter("\n");//这一句与下一句的顺序不能颠倒,原因还没搞透
191 wordApp.Selection.EndKey(ref unite, ref Nothing);
192 wordApp.Selection.ParagraphFormat.Alignment = MSWord.WdParagraphAlignment.wdAlignParagraphCenter;
193 wordApp.Selection.Font.Size = 10;//字体大小
194 wordApp.Selection.TypeText("图1 测试图片\n");
195
196 #endregion
197
198 #region 添加表格、填充数据、设置表格行列宽高、合并单元格、添加表头斜线、给单元格添加图片
199 wordDoc.Content.InsertAfter("\n");//这一句与下一句的顺序不能颠倒,原因还没搞透
200 wordApp.Selection.EndKey(ref unite, ref Nothing); //将光标移动到文档末尾
201 wordApp.Selection.ParagraphFormat.Alignment = MSWord.WdParagraphAlignment.wdAlignParagraphLeft;
202 //object WdLine2 = MSWord.WdUnits.wdLine;//换一行;
203 //wordApp.Selection.MoveDown(ref WdLine2, 6, ref Nothing);//向下跨15行输入表格,这样表格就在文字下方了,不过这是非主流的方法
204
205 //设置表格的行数和列数
206 int tableRow = 6;
207 int tableColumn = 6;
208
209 //定义一个Word中的表格对象
210 MSWord.Table table = wordDoc.Tables.Add(wordApp.Selection.Range,
211 tableRow, tableColumn, ref Nothing, ref Nothing);
212
213 //默认创建的表格没有边框,这里修改其属性,使得创建的表格带有边框
214 table.Borders.Enable = 1;//这个值可以设置得很大,例如5、13等等
215
216 //表格的索引是从1开始的。
217 wordDoc.Tables[1].Cell(1, 1).Range.Text = "列\n行";
218 for (int i = 1; i < tableRow; i++)
219 {
220 for (int j = 1; j < tableColumn; j++)
221 {
222 if (i == 1)
223 {
224 table.Cell(i, j + 1).Range.Text = "Column " + j;//填充每列的标题
225 }
226 if (j == 1)
227 {
228 table.Cell(i + 1, j).Range.Text = "Row " + i; //填充每行的标题
229 }
230 table.Cell(i + 1, j + 1).Range.Text = i + "行 " + j + "列"; //填充表格的各个小格子
231 }
232 }
233
234
235 //添加行
236 table.Rows.Add(ref Nothing);
237 table.Rows[tableRow + 1].Height = 35;//设置新增加的这行表格的高度
238 //向新添加的行的单元格中添加图片
239 string FileName = Environment.CurrentDirectory + "\\6.jpg";//图片所在路径
240 object LinkToFile = false;
241 object SaveWithDocument = true;
242 object Anchor = table.Cell(tableRow + 1, tableColumn).Range;//选中要添加图片的单元格
243 wordDoc.Application.ActiveDocument.InlineShapes.AddPicture(FileName, ref LinkToFile, ref SaveWithDocument, ref Anchor);
244
245 //由于是本文档的第2张图,所以这里是InlineShapes[2]
246 wordDoc.Application.ActiveDocument.InlineShapes[2].Width = 50;//图片宽度
247 wordDoc.Application.ActiveDocument.InlineShapes[2].Height = 35;//图片高度
248
249 // 将图片设置为四周环绕型
250 MSWord.Shape s = wordDoc.Application.ActiveDocument.InlineShapes[2].ConvertToShape();
251 s.WrapFormat.Type = MSWord.WdWrapType.wdWrapSquare;
252
253
254 //设置table样式
255 table.Rows.HeightRule = MSWord.WdRowHeightRule.wdRowHeightAtLeast;//高度规则是:行高有最低值下限?
256 table.Rows.Height = wordApp.CentimetersToPoints(float.Parse("0.8"));//
257
258 table.Range.Font.Size = 10.5F;
259 table.Range.Font.Bold = 0;
260
261 table.Range.ParagraphFormat.Alignment = MSWord.WdParagraphAlignment.wdAlignParagraphCenter;//表格文本居中
262 table.Range.Cells.VerticalAlignment = MSWord.WdCellVerticalAlignment.wdCellAlignVerticalBottom;//文本垂直贴到底部
263 //设置table边框样式
264 table.Borders.OutsideLineStyle = MSWord.WdLineStyle.wdLineStyleDouble;//表格外框是双线
265 table.Borders.InsideLineStyle = MSWord.WdLineStyle.wdLineStyleSingle;//表格内框是单线
266
267 table.Rows[1].Range.Font.Bold = 1;//加粗
268 table.Rows[1].Range.Font.Size = 12F;
269 table.Cell(1, 1).Range.Font.Size = 10.5F;
270 wordApp.Selection.Cells.Height = 30;//所有单元格的高度
271
272 //除第一行外,其他行的行高都设置为20
273 for (int i = 2; i <= tableRow; i++)
274 {
275 table.Rows[i].Height = 20;
276 }
277
278 //将表格左上角的单元格里的文字(“行” 和 “列”)居右
279 table.Cell(1, 1).Range.ParagraphFormat.Alignment = MSWord.WdParagraphAlignment.wdAlignParagraphRight;
280 //将表格左上角的单元格里面下面的“列”字移到左边,相比上一行就是将ParagraphFormat改成了Paragraphs[2].Format
281 table.Cell(1, 1).Range.Paragraphs[2].Format.Alignment = MSWord.WdParagraphAlignment.wdAlignParagraphLeft;
282
283 table.Columns[1].Width = 50;//将第 1列宽度设置为50
284
285 //将其他列的宽度都设置为75
286 for (int i = 2; i <= tableColumn; i++)
287 {
288 table.Columns[i].Width = 75;
289 }
290
291
292 //添加表头斜线,并设置表头的样式
293 table.Cell(1, 1).Borders[MSWord.WdBorderType.wdBorderDiagonalDown].Visible = true;
294 table.Cell(1, 1).Borders[MSWord.WdBorderType.wdBorderDiagonalDown].Color = MSWord.WdColor.wdColorRed;
295 table.Cell(1, 1).Borders[MSWord.WdBorderType.wdBorderDiagonalDown].LineWidth = MSWord.WdLineWidth.wdLineWidth150pt;
296
297 //合并单元格
298 table.Cell(4, 4).Merge(table.Cell(4, 5));//横向合并
299
300 table.Cell(2, 3).Merge(table.Cell(4, 3));//纵向合并,合并(2,3),(3,3),(4,3)
301
302 #endregion
303
304 wordApp.Selection.EndKey(ref unite, ref Nothing); //将光标移动到文档末尾
305
306 wordDoc.Content.InsertAfter("\n");
307 wordDoc.Content.InsertAfter("就写这么多,算了吧!2016.09.27");
308
309
310
311 //WdSaveFormat为Word 2003文档的保存格式
312 object format = MSWord.WdSaveFormat.wdFormatDocument;// office 2007就是wdFormatDocumentDefault
313 //将wordDoc文档对象的内容保存为DOCX文档
314 wordDoc.SaveAs(ref path, ref format, ref Nothing, ref Nothing, ref Nothing, ref Nothing, ref Nothing, ref Nothing, ref Nothing, ref Nothing, ref Nothing, ref Nothing, ref Nothing, ref Nothing, ref Nothing, ref Nothing);
315 //关闭wordDoc文档对象
316
317 //看是不是要打印
318 //wordDoc.PrintOut();
319
320
321
322 wordDoc.Close(ref Nothing, ref Nothing, ref Nothing);
323 //关闭wordApp组件对象
324 wordApp.Quit(ref Nothing, ref Nothing, ref Nothing);
325 Console.WriteLine(path + " 创建完毕!");
326 Console.ReadKey();
327
328
329 //我还要打开这个文档玩玩
330 MSWord.Application app = new MSWord.Application();
331 MSWord.Document doc = null;
332 try
333 {
334
335 object unknow = Type.Missing;
336 app.Visible = true;
337 string str = Environment.CurrentDirectory + "\\MyWord_Print.doc";
338 object file = str;
339 doc = app.Documents.Open(ref file,
340 ref unknow, ref unknow, ref unknow, ref unknow,
341 ref unknow, ref unknow, ref unknow, ref unknow,
342 ref unknow, ref unknow, ref unknow, ref unknow,
343 ref unknow, ref unknow, ref unknow);
344 string temp = doc.Paragraphs[1].Range.Text.Trim();
345 Console.WriteLine("你他妈输出temp干嘛?");
346 }
347 catch (Exception ex)
348 {
349 Console.WriteLine(ex.Message);
350 }
351 wordDoc = doc;
352 wordDoc.Paragraphs.Last.Range.Text += "我真的不打算再写了,就写这么多吧";
353
354 Console.ReadKey();
355 }
356
357 }
358 }
生成编辑的Word内容如下图所示:
按 Ctrl+C 复制代码
word文档工程变量的属性
//合并单元格
table.Cell(2, 2).Merge(table.Cell(2, 3));
//单元格分离
object Rownum = 2;
object Columnnum = 2;
table.Cell(2, 2).Split(ref Rownum, ref Columnnum);
//单元格对齐方式
WApp.Selection.Cells.VerticalAlignment =Microsoft.Office.Interop.Word.WdCellVerticalAlignment.wdCellAlignVerticalCenter;
//插入表行
table.Rows.Add(ref missing);
//分页 object ib = Microsoft.Office.Interop.Word.WdBreakType.wdPageBreak;
WApp.Selection.InsertBreak(ref ib);
//换行
WApp.Selection.TypeParagraph();
二、word文档设置
WApp.ActiveDocument.PageSetup.LineNumbering.Active =0;//行编号
WApp.ActiveDocument.PageSetup.Orientation =Microsoft.Office.Interop.Word.WdOrientation.wdOrientPortrait;//页面方向
WApp.ActiveDocument.PageSetup.TopMargin =WApp.CentimetersToPoints(float.Parse("2.54"));//上页边距
WApp.ActiveDocument.PageSetup.BottomMargin = WApp.CentimetersToPoints(float.Parse("2.54"));//下页边距
WApp.ActiveDocument.PageSetup.LeftMargin = WApp.CentimetersToPoints(float.Parse("3.17"));//左页边距
WApp.ActiveDocument.PageSetup.RightMargin = WApp.CentimetersToPoints(float.Parse("3.17"));//右页边距
WApp.ActiveDocument.PageSetup.Gutter = WApp.CentimetersToPoints(float.Parse("0"));//装订线位置
WApp.ActiveDocument.PageSetup.HeaderDistance = WApp.CentimetersToPoints(float.Parse("1.5"));//页眉
WApp.ActiveDocument.PageSetup.FooterDistance = WApp.CentimetersToPoints(float.Parse("1.75"));//页脚
WApp.ActiveDocument.PageSetup.PageWidth = WApp.CentimetersToPoints(float.Parse("21"));//纸张宽度
WApp.ActiveDocument.PageSetup.PageHeight = WApp.CentimetersToPoints(float.Parse("29.7"));//纸张高度
WApp.ActiveDocument.PageSetup.FirstPageTray = Microsoft.Office.Interop.Word.WdPaperTray.wdPrinterDefaultBin;//纸张来源
WApp.ActiveDocument.PageSetup.OtherPagesTray = Microsoft.Office.Interop.Word.WdPaperTray.wdPrinterDefaultBin;//纸张来源
WApp.ActiveDocument.PageSetup.SectionStart = Microsoft.Office.Interop.Word.WdSectionStart.wdSectionNewPage;//节的起始位置:新建页
WApp.ActiveDocument.PageSetup.OddAndEvenPagesHeaderFooter = 0;//页眉页脚-奇偶页不同
WApp.ActiveDocument.PageSetup.DifferentFirstPageHeaderFooter = 0;//页眉页脚-首页不同
WApp.ActiveDocument.PageSetup.VerticalAlignment = Microsoft.Office.Interop.Word.WdVerticalAlignment.wdAlignVerticalTop;//页面垂直对齐方式
WApp.ActiveDocument.PageSetup.SuppressEndnotes =0;//不隐藏尾注
WApp.ActiveDocument.PageSetup.MirrorMargins = 0;//不设置首页的内外边距
WApp.ActiveDocument.PageSetup.TwoPagesOnOne = false;//不双面打印
WApp.ActiveDocument.PageSetup.BookFoldPrinting =false;//不设置手动双面正面打印
WApp.ActiveDocument.PageSetup.BookFoldRevPrinting =false;//不设置手动双面背面打印
WApp.ActiveDocument.PageSetup.BookFoldPrintingSheets = 1;//打印默认份数
WApp.ActiveDocument.PageSetup.GutterPos = Microsoft.Office.Interop.Word.WdGutterStyle.wdGutterPosLeft;//装订线位于左侧
WApp.ActiveDocument.PageSetup.LinesPage = 40;//默认页行数量
WApp.ActiveDocument.PageSetup.LayoutMode = Microsoft.Office.Interop.Word.WdLayoutMode.wdLayoutModeLineGrid;//版式模式为“只指定行网格”
三、光标移动
//移动光标
//光标下移3行 上移3行
object unit = Microsoft.Office.Interop.Word.WdUnits.wdLine;
object count = 3;
WApp.Selection.MoveEnd(ref unit,ref count);
WApp.Selection.MoveUp(ref unit, ref count, ref missing);
//Microsoft.Office.Interop.Word.WdUnits说明
//wdCell A cell.
//wdCharacter A character.
//wdCharacterFormatting Character formatting.
//wdColumn A column.
//wdItem The selected item.
//wdLine A line. //行
//wdParagraph A paragraph.
//wdParagraphFormatting Paragraph formatting.
//wdRow A row.
//wdScreen The screen dimensions.
//wdSection A section.
//wdSentence A sentence.
//wdStory A story.
//wdTable A table.
//wdWindow A window.
//wdWord A word.
//录制的vb宏
// ,移动光标至当前行首
// Selection.HomeKey unit:=wdLine
// '移动光标至当前行尾
// Selection.EndKey unit:=wdLine
// '选择从光标至当前行首的内容
// Selection.HomeKey unit:=wdLine, Extend:=wdExtend
// '选择从光标至当前行尾的内容
// Selection.EndKey unit:=wdLine, Extend:=wdExtend
// '选择当前行
// Selection.HomeKey unit:=wdLine
// Selection.EndKey unit:=wdLine, Extend:=wdExtend
// '移动光标至文档开始
// Selection.HomeKey unit:=wdStory
// '移动光标至文档结尾
// Selection.EndKey unit:=wdStory
// '选择从光标至文档开始的内容
// Selection.HomeKey unit:=wdStory, Extend:=wdExtend
// '选择从光标至文档结尾的内容
// Selection.EndKey unit:=wdStory, Extend:=wdExtend
// '选择文档全部内容(从WholeStory可猜出Story应是当前文档的意思)
// Selection.WholeStory
// '移动光标至当前段落的开始
// Selection.MoveUp unit:=wdParagraph
// '移动光标至当前段落的结尾
// Selection.MoveDown unit:=wdParagraph
// '选择从光标至当前段落开始的内容
// Selection.MoveUp unit:=wdParagraph, Extend:=wdExtend
// '选择从光标至当前段落结尾的内容
// Selection.MoveDown unit:=wdParagraph, Extend:=wdExtend
// '选择光标所在段落的内容
// Selection.MoveUp unit:=wdParagraph
// Selection.MoveDown unit:=wdParagraph, Extend:=wdExtend
// '显示选择区的开始与结束的位置,注意:文档第1个字符的位置是0
// MsgBox ("第" & Selection.Start & "个字符至第" & Selection.End & "个字符")
// '删除当前行
// Selection.HomeKey unit:=wdLine
// Selection.EndKey unit:=wdLine, Extend:=wdExtend
// Selection.Delete
// '删除当前段落
// Selection.MoveUp unit:=wdParagraph
// Selection.MoveDown unit:=wdParagraph, Extend:=wdExtend
// Selection.Delete
//表格的光标移动
//光标到当前光标所在表格的地单元格
WApp.Selection.Tables[1].Cell(1, 1).Select();
//unit对象定义
object unith = Microsoft.Office.Interop.Word.WdUnits.wdRow;//表格行方式
object extend = Microsoft.Office.Interop.Word.WdMovementType.wdExtend;/**extend对光标移动区域进行扩展选择
object unitu = Microsoft.Office.Interop.Word.WdUnits.wdLine;//文档行方式,可以看成表格一行.不过和wdRow有区别
object unitp = Microsoft.Office.Interop.Word.WdUnits.wdParagraph;//段落方式,对于表格可以选择到表格行后的换车符,对于跨行合并的行选择,我能找到的最简单方式
object count=1;//光标移动量
下面代码演示对于存在合并单元格的选择操作.合并单元格的选择问题一直是word的bug.部分object对象参照上面代码
上面这个是表格合并样式.要如何才能选择2行标题栏尼.看下面代码
//定位到表格第1单元格
WApp.Selection.Tables[1].Cell(1, 1).Select();
//定位到第1个单元格第1个字符前
WApp.Selection.HomeKey(ref unith, ref missing);
//扩展到行尾,选择表第1行
WApp.Selection.EndKey(ref unith, ref extend);
//定义表格标题的行数量,titlerow为参数
object strtitlerow=titlerow-1;
//移动光标选择第1行的末尾段落标记
WApp.Selection.MoveDown(ref unitp, ref count, ref extend);
//选择下一行,因为合并的原因,如表格标题最后列是合并,只选择了2行的部分
WApp.Selection.MoveDown(ref unitu, ref strtitlerow, ref extend);
//扩展到该行的末端,保证合并行能全部选择到
WApp.Selection.EndKey(ref unith, ref extend);
//复制选择内容到剪贴板
WApp.Selection.Copy();
//下面是移动光标到任何位置并粘贴内容.我程序中目的是到表格换页的时候自动插入下一页的表头.
WApp.Selection.Tables[1].Cell(System.Convert.ToInt32(strRownum), 1).Select();
WApp.Selection.HomeKey(ref unith, ref missing);
WApp.Selection.Paste();
四、段落格式设定
//段落格式设定
WApp.Selection.ParagraphFormat.LeftIndent = WApp.CentimetersToPoints(float.Parse("0"));//左缩进
WApp.Selection.ParagraphFormat.RightIndent = WApp.CentimetersToPoints(float.Parse("0"));//右缩进
WApp.Selection.ParagraphFormat.SpaceBefore =float.Parse("0");//段前间距
WApp.Selection.ParagraphFormat.SpaceBeforeAuto =0;//
WApp.Selection.ParagraphFormat.SpaceAfter = float.Parse("0");//段后间距
WApp.Selection.ParagraphFormat.SpaceAfterAuto = 0;//
WApp.Selection.ParagraphFormat.LineSpacingRule = Microsoft.Office.Interop.Word.WdLineSpacing.wdLineSpaceSingle;//单倍行距
WApp.Selection.ParagraphFormat.Alignment = Microsoft.Office.Interop.Word.WdParagraphAlignment.wdAlignParagraphJustify;//段落2端对齐
WApp.Selection.ParagraphFormat.WidowControl = 0;//孤行控制
WApp.Selection.ParagraphFormat.KeepWithNext = 0;//与下段同页
WApp.Selection.ParagraphFormat.KeepTogether = 0;//段中不分页
WApp.Selection.ParagraphFormat.PageBreakBefore = 0;//段前分页
WApp.Selection.ParagraphFormat.NoLineNumber = 0;//取消行号
WApp.Selection.ParagraphFormat.Hyphenation = 1;//取消段字
WApp.Selection.ParagraphFormat.FirstLineIndent = WApp.CentimetersToPoints(float.Parse("0"));//首行缩进
WApp.Selection.ParagraphFormat.OutlineLevel = Microsoft.Office.Interop.Word.WdOutlineLevel.wdOutlineLevelBodyText;
WApp.Selection.ParagraphFormat.CharacterUnitLeftIndent = float.Parse("0");
WApp.Selection.ParagraphFormat.CharacterUnitRightIndent = float.Parse("0");
WApp.Selection.ParagraphFormat.CharacterUnitFirstLineIndent = float.Parse("0");
WApp.Selection.ParagraphFormat.LineUnitBefore = float.Parse("0");
WApp.Selection.ParagraphFormat.LineUnitAfter = float.Parse("0");
WApp.Selection.ParagraphFormat.AutoAdjustRightIndent = 1;
WApp.Selection.ParagraphFormat.DisableLineHeightGrid =0;
WApp.Selection.ParagraphFormat.FarEastLineBreakControl =1;
WApp.Selection.ParagraphFormat.WordWrap = 1;
WApp.Selection.ParagraphFormat.HangingPunctuation = 1;
WApp.Selection.ParagraphFormat.HalfWidthPunctuationOnTopOfLine = 0;
WApp.Selection.ParagraphFormat.AddSpaceBetweenFarEastAndAlpha = 1;
WApp.Selection.ParagraphFormat.AddSpaceBetweenFarEastAndDigit = 1;
WApp.Selection.ParagraphFormat.BaseLineAlignment = Microsoft.Office.Interop.Word.WdBaselineAlignment.wdBaselineAlignAuto;
五、字体格式设定
//字体格式设定
WApp.Selection.Font.NameFarEast = "华文中宋";
WApp.Selection.Font.NameAscii = "Times New Roman";
WApp.Selection.Font.NameOther = "Times New Roman";
WApp.Selection.Font.Name = "宋体";
WApp.Selection.Font.Size = float.Parse("14");
WApp.Selection.Font.Bold = 0;
WApp.Selection.Font.Italic = 0;
WApp.Selection.Font.Underline = Microsoft.Office.Interop.Word.WdUnderline.wdUnderlineNone;
WApp.Selection.Font.UnderlineColor = Microsoft.Office.Interop.Word.WdColor.wdColorAutomatic;
WApp.Selection.Font.StrikeThrough =0;//删除线
WApp.Selection.Font.DoubleStrikeThrough = 0;//双删除线
WApp.Selection.Font.Outline =0;//空心
WApp.Selection.Font.Emboss = 0;//阳文
WApp.Selection.Font.Shadow = 0;//阴影
WApp.Selection.Font.Hidden = 0;//隐藏文字
WApp.Selection.Font.SmallCaps = 0;//小型大写字母
WApp.Selection.Font.AllCaps = 0;//全部大写字母
WApp.Selection.Font.Color = Microsoft.Office.Interop.Word.WdColor.wdColorAutomatic;
WApp.Selection.Font.Engrave = 0;//阴文
WApp.Selection.Font.Superscript = 0;//上标
WApp.Selection.Font.Subscript = 0;//下标
WApp.Selection.Font.Spacing = float.Parse("0");//字符间距
WApp.Selection.Font.Scaling = 100;//字符缩放
WApp.Selection.Font.Position = 0;//位置
WApp.Selection.Font.Kerning = float.Parse("1");//字体间距调整
WApp.Selection.Font.Animation = Microsoft.Office.Interop.Word.WdAnimation.wdAnimationNone;//文字效果
WApp.Selection.Font.DisableCharacterSpaceGrid =false;
WApp.Selection.Font.EmphasisMark = Microsoft.Office.Interop.Word.WdEmphasisMark.wdEmphasisMarkNone;
六、终于找到了获取光标位置的东东。那里找到的忘了,感谢提供的老大。放到这里供大家参考。
有了这个和上面内容,相信大家对word文档的控制应该到了随心所欲的地步,爽啊
获取的c#语法 //get_Information
Selection.get_Information(WdInformation.wdActiveEndPageNumber)
//关于行号-页号-列号-位置
//information 属性
//返回有关指定的所选内容或区域的信息。variant 类型,只读。
//expression.information(type)
//expression 必需。该表达式返回一个 range 或 selection 对象。
//type long 类型,必需。需要返回的信息。可取下列 wdinformation 常量之一:
//wdactiveendadjustedpagenumber 返回页码,在该页中包含指定的所选内容或区域的活动结尾。如果设置了一个起始页码,并对页码进行了手工调整,则返回调整过的页码。
//wdactiveendpagenumber 返回页码,在该页中包含指定的所选内容或区域的活动结尾,页码从文档的开头开始计算而不考虑对页码的任何手工调整。
//wdactiveendsectionnumber 返回节号,在该节中包含了指定的所选内容或区域的活动结尾。
//wdatendofrowmarker 如果指定的所选内容或区域位于表格的行结尾标记处,则本参数返回 true。
//wdcapslock 如果大写字母锁定模式有效,则本参数返回 true。
//wdendofrangecolumnnumber 返回表格列号,在该表格列中包含了指定的所选内容或区域的活动结尾。
//wdendofrangerownumber 返回表格行号,在该表格行包含了指定的所选内容或区域的活动结尾。
//wdfirstcharactercolumnnumber 返回指定的所选内容或区域中第一个字符的位置。如果所选内容或区域是折叠的,则返回所选内容或区域右侧紧接着的字符编号。
//wdfirstcharacterlinenumber 返回所选内容中第一个字符的行号。如果 pagination 属性为 false,或 draft 属性为 true,则返回 - 1。
//wdframeisselected 如果所选内容或区域是一个完整的图文框文本框,则本参数返回 true。
//wdheaderfootertype 返回一个值,该值表明包含了指定的所选内容或区域的页眉或页脚的类型,如下表所示。 值 页眉或页脚的类型
//- 1 无
//0 偶数页页眉
//1 奇数页页眉
//2 偶数页页脚
//3 奇数页页脚
//4 第一个页眉
//5 第一个页脚
//wdhorizontalpositionrelativetopage 返回指定的所选内容或区域的水平位置。该位置是所选内容或区域的左边与页面的左边之间的距离,以磅为单位。如果所选内容或区域不可见,则返回 - 1。
//wdhorizontalpositionrelativetotextboundary 返回指定的所选内容或区域相对于周围最近的正文边界的左边的水平位置,以磅为单位。如果所选内容或区域没有显示在当前屏幕,则本参数返回 - 1。
//wdinclipboard 有关此常量的详细内容,请参阅 microsoft office 98 macintosh 版的语言参考帮助。
//wdincommentpane 如果指定的所选内容或区域位于批注窗格,则返回 true。
//wdinendnote 如果指定的所选内容或区域位于页面视图的尾注区内,或者位于普通视图的尾注窗格中,则本参数返回 true。
//wdinfootnote 如果指定的所选内容或区域位于页面视图的脚注区内,或者位于普通视图的脚注窗格中,则本参数返回 true。
//wdinfootnoteendnotepane 如果指定的所选内容或区域位于页面视图的脚注或尾注区内,或者位于普通视图的脚注或尾注窗格中,则本参数返回 true。详细内容,请参阅前面的 wdinfootnote 和 wdinendnote 的说明。
//wdinheaderfooter 如果指定的所选内容或区域位于页眉或页脚窗格中,或者位于页面视图的页眉或页脚中,则本参数返回 true。
//wdinmasterdocument 如果指定的所选内容或区域位于主控文档中,则本参数返回 true。
//wdinwordmail 返回一个值,该值表明了所选内容或区域的的位置,如下表所示。值 位置
//0 所选内容或区域不在一条电子邮件消息中。
//1 所选内容或区域位于正在发送的电子邮件中。
//2 所选内容或区域位于正在阅读的电子邮件中。
//wdmaximumnumberofcolumns 返回所选内容或区域中任何行的最大表格列数。
//wdmaximumnumberofrows 返回指定的所选内容或区域中表格的最大行数。
//wdnumberofpagesindocument 返回与所选内容或区域相关联的文档的页数。
//wdnumlock 如果 num lock 有效,则本参数返回 true。
//wdovertype 如果改写模式有效,则本参数返回 true。可用 overtype 属性改变改写模式的状态。
//wdreferenceoftype 返回一个值,该值表明所选内容相对于脚注、尾注或批注引用的位置,如下表所示。 值 描述
//— 1 所选内容或区域包含、但不只限定于脚注、尾注或批注引用中。
//0 所选内容或区域不在脚注、尾注或批注引用之前。
//1 所选内容或区域位于脚注引用之前。
//2 所选内容或区域位于尾注引用之前。
//3 所选内容或区域位于批注引用之前。
//wdrevisionmarking 如果修订功能处于活动状态,则本参数返回 true。
//wdselectionmode 返回一个值,该值表明当前的选定模式,如下表所示。 值 选定模式
//0 常规选定
//1 扩展选定
//2 列选定
//wdstartofrangecolumnnumber 返回所选内容或区域的起点所在的表格的列号。
//wdstartofrangerownumber 返回所选内容或区域的起点所在的表格的行号。
//wdverticalpositionrelativetopage 返回所选内容或区域的垂直位置,即所选内容的上边与页面的上边之间的距离,以磅为单位。如果所选内容或区域没有显示在屏幕上,则本参数返回 - 1。
//wdverticalpositionrelativetotextboundary 返回所选内容或区域相对于周围最近的正文边界的上边的垂直位置,以磅为单位。如果所选内容或区域没有显示在屏幕上,则本参数返回 - 1。
//wdwithintable 如果所选内容位于一个表格中,则本参数返回 true。
//wdzoompercentage 返回由 percentage 属性设置的当前的放大百分比。
按 Ctrl+C 复制代码本文中用C#来操作Word,包括:
创建Word;
插入文字,选择文字,编辑文字的字号、粗细、颜色、下划线等;
设置段落的首行缩进、行距;
设置页面页边距和纸张大小;
设置页眉、页码;
插入图片,设置图片宽高以及给图片添加标题;
插入表格,格式化表格,往表格中插入数据;
保存Word,打印Word;
重新打开Word等。
Visual studio版本:Visual Studio 2012(2010应该也可以)
准备工作:
/*
1. 添加引用COM里面的 Microsoft Word 12.0 Object. Library 引用(12.0表示Word 2007版本)
2. 导命名空间
using MSWord =Microsoft.Office.Interop.Word;
using System.IO;
using System.Reflection;
3. 把引用中的Microsoft.Office.Interop.Word的“属性”中的嵌入互操作设为False
*/
以下是全部代码:(代码有点长,但请不要有压力,直接复制进去就能直接成功运行)
复制代码
1 using System;
2 using System.Collections.Generic;
3 using System.Linq;
4 using System.Runtime.InteropServices;
5 using System.Text;
6 using MSWord = Microsoft.Office.Interop.Word;
7 using System.IO;
8 using System.Reflection;
9
10 namespace Console_WordSkill_All
11 {
12 class Program
13 {
14 static void Main(string[] args)
15 {
16 object path; //文件路径变量
17 string strContent; //文本内容变量
18 MSWord.Application wordApp; //Word应用程序变量
19 MSWord.Document wordDoc; //Word文档变量
20
21 path = Environment.CurrentDirectory + "\\MyWord_Print.doc";
22 wordApp = new MSWord.ApplicationClass(); //初始化
23
24 wordApp.Visible = true;//使文档可见
25
26 //如果已存在,则删除
27 if (File.Exists((string)path))
28 {
29 File.Delete((string)path);
30 }
31
32 //由于使用的是COM库,因此有许多变量需要用Missing.Value代替
33 Object Nothing = Missing.Value;
34 wordDoc = wordApp.Documents.Add(ref Nothing, ref Nothing, ref Nothing, ref Nothing);
35
36 #region 页面设置、页眉图片和文字设置,最后跳出页眉设置
37
38 //页面设置
39 wordDoc.PageSetup.PaperSize = MSWord.WdPaperSize.wdPaperA4;//设置纸张样式为A4纸
40 wordDoc.PageSetup.Orientation = MSWord.WdOrientation.wdOrientPortrait;//排列方式为垂直方向
41 wordDoc.PageSetup.TopMargin = 57.0f;
42 wordDoc.PageSetup.BottomMargin = 57.0f;
43 wordDoc.PageSetup.LeftMargin = 57.0f;
44 wordDoc.PageSetup.RightMargin = 57.0f;
45 wordDoc.PageSetup.HeaderDistance = 30.0f;//页眉位置
46
47 //设置页眉
48 wordApp.ActiveWindow.View.Type = MSWord.WdViewType.wdNormalView;//普通视图(即页面视图)样式
49 wordApp.ActiveWindow.View.SeekView = MSWord.WdSeekView.wdSeekPrimaryHeader;//进入页眉设置,其中页眉边距在页面设置中已完成
50 wordApp.Selection.ParagraphFormat.Alignment = MSWord.WdParagraphAlignment.wdAlignParagraphRight;//页眉中的文字右对齐
51
52
53 //插入页眉图片(测试结果图片未插入成功)
54 wordApp.Selection.ParagraphFormat.Alignment = MSWord.WdParagraphAlignment.wdAlignParagraphCenter;
55 string headerfile = @"C:\Users\xiahui\Desktop\OficeProgram\3.jpg";
56 MSWord.InlineShape shape1 = wordApp.ActiveWindow.ActivePane.Selection.InlineShapes.AddPicture(headerfile, ref Nothing, ref Nothing, ref Nothing);
57 shape1.Height = 5;//强行设置貌似无效,图片没有按设置的缩放——图片的比例并没有改变。
58 shape1.Width = 20;
59 wordApp.ActiveWindow.ActivePane.Selection.InsertAfter(" 文档页眉");//在页眉的图片后面追加几个字
60
61 //去掉页眉的横线
62 wordApp.ActiveWindow.ActivePane.Selection.ParagraphFormat.Borders[MSWord.WdBorderType.wdBorderBottom].LineStyle = MSWord.WdLineStyle.wdLineStyleNone;
63 wordApp.ActiveWindow.ActivePane.Selection.Borders[MSWord.WdBorderType.wdBorderBottom].Visible = false;
64 wordApp.ActiveWindow.ActivePane.View.SeekView = MSWord.WdSeekView.wdSeekMainDocument;//退出页眉设置
65 #endregion
66
67 #region 页码设置并添加页码
68
69 //为当前页添加页码
70 MSWord.PageNumbers pns = wordApp.Selection.Sections[1].Headers[MSWord.WdHeaderFooterIndex.wdHeaderFooterEvenPages].PageNumbers;//获取当前页的号码
71 pns.NumberStyle = MSWord.WdPageNumberStyle.wdPageNumberStyleNumberInDash;//设置页码的风格,是Dash形还是圆形的
72 pns.HeadingLevelForChapter = 0;
73 pns.IncludeChapterNumber = false;
74 pns.RestartNumberingAtSection = false;
75 pns.StartingNumber = 0; //开始页页码?
76 object pagenmbetal = MSWord.WdPageNumberAlignment.wdAlignPageNumberCenter;//将号码设置在中间
77 object first = true;
78 wordApp.Selection.Sections[1].Footers[MSWord.WdHeaderFooterIndex.wdHeaderFooterEvenPages].PageNumbers.Add(ref pagenmbetal, ref first);
79
80 #endregion
81
82 #region 行间距与缩进、文本字体、字号、加粗、斜体、颜色、下划线、下划线颜色设置
83
84 wordApp.Selection.ParagraphFormat.LineSpacing = 16f;//设置文档的行间距
85 wordApp.Selection.ParagraphFormat.FirstLineIndent = 30;//首行缩进的长度
86 //写入普通文本
87 strContent = "我是普通文本\n";
88 wordDoc.Paragraphs.Last.Range.Text = strContent;
89
90 wordDoc.Paragraphs.Last.Range.Text = "我再加一行试试,这里不加'\\n'";
91 //直接添加段,不是覆盖( += )
92 wordDoc.Paragraphs.Last.Range.Text += "不会覆盖的,";
93
94 //添加在此段的文字后面,不是新段落
95 wordDoc.Paragraphs.Last.Range.InsertAfter("这是后面的内容\n");
96
97 //将文档的前4个字替换成"哥是替换文字",并将其颜色设为红色
98 object start = 0;
99 object end = 4;
100 MSWord.Range rang = wordDoc.Range(ref start, ref end);
101 rang.Font.Color = MSWord.WdColor.wdColorRed;
102 rang.Text = "哥是替换文字";
103 wordDoc.Range(ref start, ref end);
104
105 //写入黑体文本
106 object unite = MSWord.WdUnits.wdStory;
107 wordApp.Selection.EndKey(ref unite, ref Nothing);//将光标移到文本末尾
108 wordApp.Selection.ParagraphFormat.FirstLineIndent = 0;//取消首行缩进的长度
109 strContent = "这是黑体文本\n";
110 wordDoc.Paragraphs.Last.Range.Font.Name = "黑体";
111 wordDoc.Paragraphs.Last.Range.Text = strContent;
112
113 //写入加粗文本
114 strContent = "这是粗体文本\n"; //
115 wordApp.Selection.EndKey(ref unite, ref Nothing);//这一句不加,有时候好像也不出问题,不过还是加了安全
116 wordDoc.Paragraphs.Last.Range.Font.Bold = 1;
117 wordDoc.Paragraphs.Last.Range.Text = strContent;
118
119 //写入15号字体文本
120 strContent = "我这个文本的字号是15号,而且是宋体\n";
121 wordApp.Selection.EndKey(ref unite, ref Nothing);
122 wordDoc.Paragraphs.Last.Range.Font.Size = 15;
123 wordDoc.Paragraphs.Last.Range.Font.Name = "宋体";
124 wordDoc.Paragraphs.Last.Range.Text = strContent;
125
126 //写入斜体文本
127 strContent = "我是斜体字文本\n";
128 wordApp.Selection.EndKey(ref unite, ref Nothing);
129 wordDoc.Paragraphs.Last.Range.Font.Italic = 1;
130 wordDoc.Paragraphs.Last.Range.Text = strContent;
131
132 //写入蓝色文本
133 strContent = "我是蓝色的文本\n";
134 wordApp.Selection.EndKey(ref unite, ref Nothing);
135 wordDoc.Paragraphs.Last.Range.Font.Color = MSWord.WdColor.wdColorBlue;
136 wordDoc.Paragraphs.Last.Range.Text = strContent;
137
138 //写入下划线文本
139 strContent = "我是下划线文本\n";
140 wordApp.Selection.EndKey(ref unite, ref Nothing);
141 wordDoc.Paragraphs.Last.Range.Font.Underline = MSWord.WdUnderline.wdUnderlineThick;
142 wordDoc.Paragraphs.Last.Range.Text = strContent;
143
144 //写入红色下画线文本
145 strContent = "我是点线下划线,并且下划线是红色的\n";
146 wordApp.Selection.EndKey(ref unite, ref Nothing);
147 wordDoc.Paragraphs.Last.Range.Font.Underline = MSWord.WdUnderline.wdUnderlineDottedHeavy;
148 wordDoc.Paragraphs.Last.Range.Font.UnderlineColor = MSWord.WdColor.wdColorRed;
149 wordDoc.Paragraphs.Last.Range.Text = strContent;
150
151 //取消下划线,并且将字号调整为12号
152 strContent = "我他妈不要下划线了,并且设置字号为12号,黑色不要斜体\n";
153 wordApp.Selection.EndKey(ref unite, ref Nothing);
154 wordDoc.Paragraphs.Last.Range.Font.Size = 12;
155 wordDoc.Paragraphs.Last.Range.Font.Underline = MSWord.WdUnderline.wdUnderlineNone;
156 wordDoc.Paragraphs.Last.Range.Font.Color = MSWord.WdColor.wdColorBlack;
157 wordDoc.Paragraphs.Last.Range.Font.Italic = 0;
158 wordDoc.Paragraphs.Last.Range.Text = strContent;
159
160
161 #endregion
162
163
164 #region 插入图片、居中显示,设置图片的绝对尺寸和缩放尺寸,并给图片添加标题
165
166 wordApp.Selection.EndKey(ref unite, ref Nothing); //将光标移动到文档末尾
167 //图片文件的路径
168 string filename = Environment.CurrentDirectory + "\\6.jpg";
169 //要向Word文档中插入图片的位置
170 Object range = wordDoc.Paragraphs.Last.Range;
171 //定义该插入的图片是否为外部链接
172 Object linkToFile = false; //默认,这里貌似设置为bool类型更清晰一些
173 //定义要插入的图片是否随Word文档一起保存
174 Object saveWithDocument = true; //默认
175 //使用InlineShapes.AddPicture方法(【即“嵌入型”】)插入图片
176 wordDoc.InlineShapes.AddPicture(filename, ref linkToFile, ref saveWithDocument, ref range);
177 wordApp.Selection.ParagraphFormat.Alignment = MSWord.WdParagraphAlignment.wdAlignParagraphCenter;//居中显示图片
178
179 //设置图片宽高的绝对大小
180
181 //wordDoc.InlineShapes[1].Width = 200;
182 //wordDoc.InlineShapes[1].Height = 150;
183 //按比例缩放大小
184
185 wordDoc.InlineShapes[1].ScaleWidth = 20;//缩小到20% ?
186 wordDoc.InlineShapes[1].ScaleHeight = 20;
187
188 //在图下方居中添加图片标题
189
190 wordDoc.Content.InsertAfter("\n");//这一句与下一句的顺序不能颠倒,原因还没搞透
191 wordApp.Selection.EndKey(ref unite, ref Nothing);
192 wordApp.Selection.ParagraphFormat.Alignment = MSWord.WdParagraphAlignment.wdAlignParagraphCenter;
193 wordApp.Selection.Font.Size = 10;//字体大小
194 wordApp.Selection.TypeText("图1 测试图片\n");
195
196 #endregion
197
198 #region 添加表格、填充数据、设置表格行列宽高、合并单元格、添加表头斜线、给单元格添加图片
199 wordDoc.Content.InsertAfter("\n");//这一句与下一句的顺序不能颠倒,原因还没搞透
200 wordApp.Selection.EndKey(ref unite, ref Nothing); //将光标移动到文档末尾
201 wordApp.Selection.ParagraphFormat.Alignment = MSWord.WdParagraphAlignment.wdAlignParagraphLeft;
202 //object WdLine2 = MSWord.WdUnits.wdLine;//换一行;
203 //wordApp.Selection.MoveDown(ref WdLine2, 6, ref Nothing);//向下跨15行输入表格,这样表格就在文字下方了,不过这是非主流的方法
204
205 //设置表格的行数和列数
206 int tableRow = 6;
207 int tableColumn = 6;
208
209 //定义一个Word中的表格对象
210 MSWord.Table table = wordDoc.Tables.Add(wordApp.Selection.Range,
211 tableRow, tableColumn, ref Nothing, ref Nothing);
212
213 //默认创建的表格没有边框,这里修改其属性,使得创建的表格带有边框
214 table.Borders.Enable = 1;//这个值可以设置得很大,例如5、13等等
215
216 //表格的索引是从1开始的。
217 wordDoc.Tables[1].Cell(1, 1).Range.Text = "列\n行";
218 for (int i = 1; i < tableRow; i++)
219 {
220 for (int j = 1; j < tableColumn; j++)
221 {
222 if (i == 1)
223 {
224 table.Cell(i, j + 1).Range.Text = "Column " + j;//填充每列的标题
225 }
226 if (j == 1)
227 {
228 table.Cell(i + 1, j).Range.Text = "Row " + i; //填充每行的标题
229 }
230 table.Cell(i + 1, j + 1).Range.Text = i + "行 " + j + "列"; //填充表格的各个小格子
231 }
232 }
233
234
235 //添加行
236 table.Rows.Add(ref Nothing);
237 table.Rows[tableRow + 1].Height = 35;//设置新增加的这行表格的高度
238 //向新添加的行的单元格中添加图片
239 string FileName = Environment.CurrentDirectory + "\\6.jpg";//图片所在路径
240 object LinkToFile = false;
241 object SaveWithDocument = true;
242 object Anchor = table.Cell(tableRow + 1, tableColumn).Range;//选中要添加图片的单元格
243 wordDoc.Application.ActiveDocument.InlineShapes.AddPicture(FileName, ref LinkToFile, ref SaveWithDocument, ref Anchor);
244
245 //由于是本文档的第2张图,所以这里是InlineShapes[2]
246 wordDoc.Application.ActiveDocument.InlineShapes[2].Width = 50;//图片宽度
247 wordDoc.Application.ActiveDocument.InlineShapes[2].Height = 35;//图片高度
248
249 // 将图片设置为四周环绕型
250 MSWord.Shape s = wordDoc.Application.ActiveDocument.InlineShapes[2].ConvertToShape();
251 s.WrapFormat.Type = MSWord.WdWrapType.wdWrapSquare;
252
253
254 //设置table样式
255 table.Rows.HeightRule = MSWord.WdRowHeightRule.wdRowHeightAtLeast;//高度规则是:行高有最低值下限?
256 table.Rows.Height = wordApp.CentimetersToPoints(float.Parse("0.8"));//
257
258 table.Range.Font.Size = 10.5F;
259 table.Range.Font.Bold = 0;
260
261 table.Range.ParagraphFormat.Alignment = MSWord.WdParagraphAlignment.wdAlignParagraphCenter;//表格文本居中
262 table.Range.Cells.VerticalAlignment = MSWord.WdCellVerticalAlignment.wdCellAlignVerticalBottom;//文本垂直贴到底部
263 //设置table边框样式
264 table.Borders.OutsideLineStyle = MSWord.WdLineStyle.wdLineStyleDouble;//表格外框是双线
265 table.Borders.InsideLineStyle = MSWord.WdLineStyle.wdLineStyleSingle;//表格内框是单线
266
267 table.Rows[1].Range.Font.Bold = 1;//加粗
268 table.Rows[1].Range.Font.Size = 12F;
269 table.Cell(1, 1).Range.Font.Size = 10.5F;
270 wordApp.Selection.Cells.Height = 30;//所有单元格的高度
271
272 //除第一行外,其他行的行高都设置为20
273 for (int i = 2; i <= tableRow; i++)
274 {
275 table.Rows[i].Height = 20;
276 }
277
278 //将表格左上角的单元格里的文字(“行” 和 “列”)居右
279 table.Cell(1, 1).Range.ParagraphFormat.Alignment = MSWord.WdParagraphAlignment.wdAlignParagraphRight;
280 //将表格左上角的单元格里面下面的“列”字移到左边,相比上一行就是将ParagraphFormat改成了Paragraphs[2].Format
281 table.Cell(1, 1).Range.Paragraphs[2].Format.Alignment = MSWord.WdParagraphAlignment.wdAlignParagraphLeft;
282
283 table.Columns[1].Width = 50;//将第 1列宽度设置为50
284
285 //将其他列的宽度都设置为75
286 for (int i = 2; i <= tableColumn; i++)
287 {
288 table.Columns[i].Width = 75;
289 }
290
291
292 //添加表头斜线,并设置表头的样式
293 table.Cell(1, 1).Borders[MSWord.WdBorderType.wdBorderDiagonalDown].Visible = true;
294 table.Cell(1, 1).Borders[MSWord.WdBorderType.wdBorderDiagonalDown].Color = MSWord.WdColor.wdColorRed;
295 table.Cell(1, 1).Borders[MSWord.WdBorderType.wdBorderDiagonalDown].LineWidth = MSWord.WdLineWidth.wdLineWidth150pt;
296
297 //合并单元格
298 table.Cell(4, 4).Merge(table.Cell(4, 5));//横向合并
299
300 table.Cell(2, 3).Merge(table.Cell(4, 3));//纵向合并,合并(2,3),(3,3),(4,3)
301
302 #endregion
303
304 wordApp.Selection.EndKey(ref unite, ref Nothing); //将光标移动到文档末尾
305
306 wordDoc.Content.InsertAfter("\n");
307 wordDoc.Content.InsertAfter("就写这么多,算了吧!2016.09.27");
308
309
310
311 //WdSaveFormat为Word 2003文档的保存格式
312 object format = MSWord.WdSaveFormat.wdFormatDocument;// office 2007就是wdFormatDocumentDefault
313 //将wordDoc文档对象的内容保存为DOCX文档
314 wordDoc.SaveAs(ref path, ref format, ref Nothing, ref Nothing, ref Nothing, ref Nothing, ref Nothing, ref Nothing, ref Nothing, ref Nothing, ref Nothing, ref Nothing, ref Nothing, ref Nothing, ref Nothing, ref Nothing);
315 //关闭wordDoc文档对象
316
317 //看是不是要打印
318 //wordDoc.PrintOut();
319
320
321
322 wordDoc.Close(ref Nothing, ref Nothing, ref Nothing);
323 //关闭wordApp组件对象
324 wordApp.Quit(ref Nothing, ref Nothing, ref Nothing);
325 Console.WriteLine(path + " 创建完毕!");
326 Console.ReadKey();
327
328
329 //我还要打开这个文档玩玩
330 MSWord.Application app = new MSWord.Application();
331 MSWord.Document doc = null;
332 try
333 {
334
335 object unknow = Type.Missing;
336 app.Visible = true;
337 string str = Environment.CurrentDirectory + "\\MyWord_Print.doc";
338 object file = str;
339 doc = app.Documents.Open(ref file,
340 ref unknow, ref unknow, ref unknow, ref unknow,
341 ref unknow, ref unknow, ref unknow, ref unknow,
342 ref unknow, ref unknow, ref unknow, ref unknow,
343 ref unknow, ref unknow, ref unknow);
344 string temp = doc.Paragraphs[1].Range.Text.Trim();
345 Console.WriteLine("你他妈输出temp干嘛?");
346 }
347 catch (Exception ex)
348 {
349 Console.WriteLine(ex.Message);
350 }
351 wordDoc = doc;
352 wordDoc.Paragraphs.Last.Range.Text += "我真的不打算再写了,就写这么多吧";
353
354 Console.ReadKey();
355 }
356
357 }
358 }
生成编辑的Word内容如下图所示:
按 Ctrl+C 复制代码
word文档工程变量的属性
//合并单元格
table.Cell(2, 2).Merge(table.Cell(2, 3));
//单元格分离
object Rownum = 2;
object Columnnum = 2;
table.Cell(2, 2).Split(ref Rownum, ref Columnnum);
//单元格对齐方式
WApp.Selection.Cells.VerticalAlignment =Microsoft.Office.Interop.Word.WdCellVerticalAlignment.wdCellAlignVerticalCenter;
//插入表行
table.Rows.Add(ref missing);
//分页 object ib = Microsoft.Office.Interop.Word.WdBreakType.wdPageBreak;
WApp.Selection.InsertBreak(ref ib);
//换行
WApp.Selection.TypeParagraph();
二、word文档设置
WApp.ActiveDocument.PageSetup.LineNumbering.Active =0;//行编号
WApp.ActiveDocument.PageSetup.Orientation =Microsoft.Office.Interop.Word.WdOrientation.wdOrientPortrait;//页面方向
WApp.ActiveDocument.PageSetup.TopMargin =WApp.CentimetersToPoints(float.Parse("2.54"));//上页边距
WApp.ActiveDocument.PageSetup.BottomMargin = WApp.CentimetersToPoints(float.Parse("2.54"));//下页边距
WApp.ActiveDocument.PageSetup.LeftMargin = WApp.CentimetersToPoints(float.Parse("3.17"));//左页边距
WApp.ActiveDocument.PageSetup.RightMargin = WApp.CentimetersToPoints(float.Parse("3.17"));//右页边距
WApp.ActiveDocument.PageSetup.Gutter = WApp.CentimetersToPoints(float.Parse("0"));//装订线位置
WApp.ActiveDocument.PageSetup.HeaderDistance = WApp.CentimetersToPoints(float.Parse("1.5"));//页眉
WApp.ActiveDocument.PageSetup.FooterDistance = WApp.CentimetersToPoints(float.Parse("1.75"));//页脚
WApp.ActiveDocument.PageSetup.PageWidth = WApp.CentimetersToPoints(float.Parse("21"));//纸张宽度
WApp.ActiveDocument.PageSetup.PageHeight = WApp.CentimetersToPoints(float.Parse("29.7"));//纸张高度
WApp.ActiveDocument.PageSetup.FirstPageTray = Microsoft.Office.Interop.Word.WdPaperTray.wdPrinterDefaultBin;//纸张来源
WApp.ActiveDocument.PageSetup.OtherPagesTray = Microsoft.Office.Interop.Word.WdPaperTray.wdPrinterDefaultBin;//纸张来源
WApp.ActiveDocument.PageSetup.SectionStart = Microsoft.Office.Interop.Word.WdSectionStart.wdSectionNewPage;//节的起始位置:新建页
WApp.ActiveDocument.PageSetup.OddAndEvenPagesHeaderFooter = 0;//页眉页脚-奇偶页不同
WApp.ActiveDocument.PageSetup.DifferentFirstPageHeaderFooter = 0;//页眉页脚-首页不同
WApp.ActiveDocument.PageSetup.VerticalAlignment = Microsoft.Office.Interop.Word.WdVerticalAlignment.wdAlignVerticalTop;//页面垂直对齐方式
WApp.ActiveDocument.PageSetup.SuppressEndnotes =0;//不隐藏尾注
WApp.ActiveDocument.PageSetup.MirrorMargins = 0;//不设置首页的内外边距
WApp.ActiveDocument.PageSetup.TwoPagesOnOne = false;//不双面打印
WApp.ActiveDocument.PageSetup.BookFoldPrinting =false;//不设置手动双面正面打印
WApp.ActiveDocument.PageSetup.BookFoldRevPrinting =false;//不设置手动双面背面打印
WApp.ActiveDocument.PageSetup.BookFoldPrintingSheets = 1;//打印默认份数
WApp.ActiveDocument.PageSetup.GutterPos = Microsoft.Office.Interop.Word.WdGutterStyle.wdGutterPosLeft;//装订线位于左侧
WApp.ActiveDocument.PageSetup.LinesPage = 40;//默认页行数量
WApp.ActiveDocument.PageSetup.LayoutMode = Microsoft.Office.Interop.Word.WdLayoutMode.wdLayoutModeLineGrid;//版式模式为“只指定行网格”
三、光标移动
//移动光标
//光标下移3行 上移3行
object unit = Microsoft.Office.Interop.Word.WdUnits.wdLine;
object count = 3;
WApp.Selection.MoveEnd(ref unit,ref count);
WApp.Selection.MoveUp(ref unit, ref count, ref missing);
//Microsoft.Office.Interop.Word.WdUnits说明
//wdCell A cell.
//wdCharacter A character.
//wdCharacterFormatting Character formatting.
//wdColumn A column.
//wdItem The selected item.
//wdLine A line. //行
//wdParagraph A paragraph.
//wdParagraphFormatting Paragraph formatting.
//wdRow A row.
//wdScreen The screen dimensions.
//wdSection A section.
//wdSentence A sentence.
//wdStory A story.
//wdTable A table.
//wdWindow A window.
//wdWord A word.
//录制的vb宏
// ,移动光标至当前行首
// Selection.HomeKey unit:=wdLine
// '移动光标至当前行尾
// Selection.EndKey unit:=wdLine
// '选择从光标至当前行首的内容
// Selection.HomeKey unit:=wdLine, Extend:=wdExtend
// '选择从光标至当前行尾的内容
// Selection.EndKey unit:=wdLine, Extend:=wdExtend
// '选择当前行
// Selection.HomeKey unit:=wdLine
// Selection.EndKey unit:=wdLine, Extend:=wdExtend
// '移动光标至文档开始
// Selection.HomeKey unit:=wdStory
// '移动光标至文档结尾
// Selection.EndKey unit:=wdStory
// '选择从光标至文档开始的内容
// Selection.HomeKey unit:=wdStory, Extend:=wdExtend
// '选择从光标至文档结尾的内容
// Selection.EndKey unit:=wdStory, Extend:=wdExtend
// '选择文档全部内容(从WholeStory可猜出Story应是当前文档的意思)
// Selection.WholeStory
// '移动光标至当前段落的开始
// Selection.MoveUp unit:=wdParagraph
// '移动光标至当前段落的结尾
// Selection.MoveDown unit:=wdParagraph
// '选择从光标至当前段落开始的内容
// Selection.MoveUp unit:=wdParagraph, Extend:=wdExtend
// '选择从光标至当前段落结尾的内容
// Selection.MoveDown unit:=wdParagraph, Extend:=wdExtend
// '选择光标所在段落的内容
// Selection.MoveUp unit:=wdParagraph
// Selection.MoveDown unit:=wdParagraph, Extend:=wdExtend
// '显示选择区的开始与结束的位置,注意:文档第1个字符的位置是0
// MsgBox ("第" & Selection.Start & "个字符至第" & Selection.End & "个字符")
// '删除当前行
// Selection.HomeKey unit:=wdLine
// Selection.EndKey unit:=wdLine, Extend:=wdExtend
// Selection.Delete
// '删除当前段落
// Selection.MoveUp unit:=wdParagraph
// Selection.MoveDown unit:=wdParagraph, Extend:=wdExtend
// Selection.Delete
//表格的光标移动
//光标到当前光标所在表格的地单元格
WApp.Selection.Tables[1].Cell(1, 1).Select();
//unit对象定义
object unith = Microsoft.Office.Interop.Word.WdUnits.wdRow;//表格行方式
object extend = Microsoft.Office.Interop.Word.WdMovementType.wdExtend;/**extend对光标移动区域进行扩展选择
object unitu = Microsoft.Office.Interop.Word.WdUnits.wdLine;//文档行方式,可以看成表格一行.不过和wdRow有区别
object unitp = Microsoft.Office.Interop.Word.WdUnits.wdParagraph;//段落方式,对于表格可以选择到表格行后的换车符,对于跨行合并的行选择,我能找到的最简单方式
object count=1;//光标移动量
下面代码演示对于存在合并单元格的选择操作.合并单元格的选择问题一直是word的bug.部分object对象参照上面代码
上面这个是表格合并样式.要如何才能选择2行标题栏尼.看下面代码
//定位到表格第1单元格
WApp.Selection.Tables[1].Cell(1, 1).Select();
//定位到第1个单元格第1个字符前
WApp.Selection.HomeKey(ref unith, ref missing);
//扩展到行尾,选择表第1行
WApp.Selection.EndKey(ref unith, ref extend);
//定义表格标题的行数量,titlerow为参数
object strtitlerow=titlerow-1;
//移动光标选择第1行的末尾段落标记
WApp.Selection.MoveDown(ref unitp, ref count, ref extend);
//选择下一行,因为合并的原因,如表格标题最后列是合并,只选择了2行的部分
WApp.Selection.MoveDown(ref unitu, ref strtitlerow, ref extend);
//扩展到该行的末端,保证合并行能全部选择到
WApp.Selection.EndKey(ref unith, ref extend);
//复制选择内容到剪贴板
WApp.Selection.Copy();
//下面是移动光标到任何位置并粘贴内容.我程序中目的是到表格换页的时候自动插入下一页的表头.
WApp.Selection.Tables[1].Cell(System.Convert.ToInt32(strRownum), 1).Select();
WApp.Selection.HomeKey(ref unith, ref missing);
WApp.Selection.Paste();
四、段落格式设定
//段落格式设定
WApp.Selection.ParagraphFormat.LeftIndent = WApp.CentimetersToPoints(float.Parse("0"));//左缩进
WApp.Selection.ParagraphFormat.RightIndent = WApp.CentimetersToPoints(float.Parse("0"));//右缩进
WApp.Selection.ParagraphFormat.SpaceBefore =float.Parse("0");//段前间距
WApp.Selection.ParagraphFormat.SpaceBeforeAuto =0;//
WApp.Selection.ParagraphFormat.SpaceAfter = float.Parse("0");//段后间距
WApp.Selection.ParagraphFormat.SpaceAfterAuto = 0;//
WApp.Selection.ParagraphFormat.LineSpacingRule = Microsoft.Office.Interop.Word.WdLineSpacing.wdLineSpaceSingle;//单倍行距
WApp.Selection.ParagraphFormat.Alignment = Microsoft.Office.Interop.Word.WdParagraphAlignment.wdAlignParagraphJustify;//段落2端对齐
WApp.Selection.ParagraphFormat.WidowControl = 0;//孤行控制
WApp.Selection.ParagraphFormat.KeepWithNext = 0;//与下段同页
WApp.Selection.ParagraphFormat.KeepTogether = 0;//段中不分页
WApp.Selection.ParagraphFormat.PageBreakBefore = 0;//段前分页
WApp.Selection.ParagraphFormat.NoLineNumber = 0;//取消行号
WApp.Selection.ParagraphFormat.Hyphenation = 1;//取消段字
WApp.Selection.ParagraphFormat.FirstLineIndent = WApp.CentimetersToPoints(float.Parse("0"));//首行缩进
WApp.Selection.ParagraphFormat.OutlineLevel = Microsoft.Office.Interop.Word.WdOutlineLevel.wdOutlineLevelBodyText;
WApp.Selection.ParagraphFormat.CharacterUnitLeftIndent = float.Parse("0");
WApp.Selection.ParagraphFormat.CharacterUnitRightIndent = float.Parse("0");
WApp.Selection.ParagraphFormat.CharacterUnitFirstLineIndent = float.Parse("0");
WApp.Selection.ParagraphFormat.LineUnitBefore = float.Parse("0");
WApp.Selection.ParagraphFormat.LineUnitAfter = float.Parse("0");
WApp.Selection.ParagraphFormat.AutoAdjustRightIndent = 1;
WApp.Selection.ParagraphFormat.DisableLineHeightGrid =0;
WApp.Selection.ParagraphFormat.FarEastLineBreakControl =1;
WApp.Selection.ParagraphFormat.WordWrap = 1;
WApp.Selection.ParagraphFormat.HangingPunctuation = 1;
WApp.Selection.ParagraphFormat.HalfWidthPunctuationOnTopOfLine = 0;
WApp.Selection.ParagraphFormat.AddSpaceBetweenFarEastAndAlpha = 1;
WApp.Selection.ParagraphFormat.AddSpaceBetweenFarEastAndDigit = 1;
WApp.Selection.ParagraphFormat.BaseLineAlignment = Microsoft.Office.Interop.Word.WdBaselineAlignment.wdBaselineAlignAuto;
五、字体格式设定
//字体格式设定
WApp.Selection.Font.NameFarEast = "华文中宋";
WApp.Selection.Font.NameAscii = "Times New Roman";
WApp.Selection.Font.NameOther = "Times New Roman";
WApp.Selection.Font.Name = "宋体";
WApp.Selection.Font.Size = float.Parse("14");
WApp.Selection.Font.Bold = 0;
WApp.Selection.Font.Italic = 0;
WApp.Selection.Font.Underline = Microsoft.Office.Interop.Word.WdUnderline.wdUnderlineNone;
WApp.Selection.Font.UnderlineColor = Microsoft.Office.Interop.Word.WdColor.wdColorAutomatic;
WApp.Selection.Font.StrikeThrough =0;//删除线
WApp.Selection.Font.DoubleStrikeThrough = 0;//双删除线
WApp.Selection.Font.Outline =0;//空心
WApp.Selection.Font.Emboss = 0;//阳文
WApp.Selection.Font.Shadow = 0;//阴影
WApp.Selection.Font.Hidden = 0;//隐藏文字
WApp.Selection.Font.SmallCaps = 0;//小型大写字母
WApp.Selection.Font.AllCaps = 0;//全部大写字母
WApp.Selection.Font.Color = Microsoft.Office.Interop.Word.WdColor.wdColorAutomatic;
WApp.Selection.Font.Engrave = 0;//阴文
WApp.Selection.Font.Superscript = 0;//上标
WApp.Selection.Font.Subscript = 0;//下标
WApp.Selection.Font.Spacing = float.Parse("0");//字符间距
WApp.Selection.Font.Scaling = 100;//字符缩放
WApp.Selection.Font.Position = 0;//位置
WApp.Selection.Font.Kerning = float.Parse("1");//字体间距调整
WApp.Selection.Font.Animation = Microsoft.Office.Interop.Word.WdAnimation.wdAnimationNone;//文字效果
WApp.Selection.Font.DisableCharacterSpaceGrid =false;
WApp.Selection.Font.EmphasisMark = Microsoft.Office.Interop.Word.WdEmphasisMark.wdEmphasisMarkNone;
六、终于找到了获取光标位置的东东。那里找到的忘了,感谢提供的老大。放到这里供大家参考。
有了这个和上面内容,相信大家对word文档的控制应该到了随心所欲的地步,爽啊
获取的c#语法 //get_Information
Selection.get_Information(WdInformation.wdActiveEndPageNumber)
//关于行号-页号-列号-位置
//information 属性
//返回有关指定的所选内容或区域的信息。variant 类型,只读。
//expression.information(type)
//expression 必需。该表达式返回一个 range 或 selection 对象。
//type long 类型,必需。需要返回的信息。可取下列 wdinformation 常量之一:
//wdactiveendadjustedpagenumber 返回页码,在该页中包含指定的所选内容或区域的活动结尾。如果设置了一个起始页码,并对页码进行了手工调整,则返回调整过的页码。
//wdactiveendpagenumber 返回页码,在该页中包含指定的所选内容或区域的活动结尾,页码从文档的开头开始计算而不考虑对页码的任何手工调整。
//wdactiveendsectionnumber 返回节号,在该节中包含了指定的所选内容或区域的活动结尾。
//wdatendofrowmarker 如果指定的所选内容或区域位于表格的行结尾标记处,则本参数返回 true。
//wdcapslock 如果大写字母锁定模式有效,则本参数返回 true。
//wdendofrangecolumnnumber 返回表格列号,在该表格列中包含了指定的所选内容或区域的活动结尾。
//wdendofrangerownumber 返回表格行号,在该表格行包含了指定的所选内容或区域的活动结尾。
//wdfirstcharactercolumnnumber 返回指定的所选内容或区域中第一个字符的位置。如果所选内容或区域是折叠的,则返回所选内容或区域右侧紧接着的字符编号。
//wdfirstcharacterlinenumber 返回所选内容中第一个字符的行号。如果 pagination 属性为 false,或 draft 属性为 true,则返回 - 1。
//wdframeisselected 如果所选内容或区域是一个完整的图文框文本框,则本参数返回 true。
//wdheaderfootertype 返回一个值,该值表明包含了指定的所选内容或区域的页眉或页脚的类型,如下表所示。 值 页眉或页脚的类型
//- 1 无
//0 偶数页页眉
//1 奇数页页眉
//2 偶数页页脚
//3 奇数页页脚
//4 第一个页眉
//5 第一个页脚
//wdhorizontalpositionrelativetopage 返回指定的所选内容或区域的水平位置。该位置是所选内容或区域的左边与页面的左边之间的距离,以磅为单位。如果所选内容或区域不可见,则返回 - 1。
//wdhorizontalpositionrelativetotextboundary 返回指定的所选内容或区域相对于周围最近的正文边界的左边的水平位置,以磅为单位。如果所选内容或区域没有显示在当前屏幕,则本参数返回 - 1。
//wdinclipboard 有关此常量的详细内容,请参阅 microsoft office 98 macintosh 版的语言参考帮助。
//wdincommentpane 如果指定的所选内容或区域位于批注窗格,则返回 true。
//wdinendnote 如果指定的所选内容或区域位于页面视图的尾注区内,或者位于普通视图的尾注窗格中,则本参数返回 true。
//wdinfootnote 如果指定的所选内容或区域位于页面视图的脚注区内,或者位于普通视图的脚注窗格中,则本参数返回 true。
//wdinfootnoteendnotepane 如果指定的所选内容或区域位于页面视图的脚注或尾注区内,或者位于普通视图的脚注或尾注窗格中,则本参数返回 true。详细内容,请参阅前面的 wdinfootnote 和 wdinendnote 的说明。
//wdinheaderfooter 如果指定的所选内容或区域位于页眉或页脚窗格中,或者位于页面视图的页眉或页脚中,则本参数返回 true。
//wdinmasterdocument 如果指定的所选内容或区域位于主控文档中,则本参数返回 true。
//wdinwordmail 返回一个值,该值表明了所选内容或区域的的位置,如下表所示。值 位置
//0 所选内容或区域不在一条电子邮件消息中。
//1 所选内容或区域位于正在发送的电子邮件中。
//2 所选内容或区域位于正在阅读的电子邮件中。
//wdmaximumnumberofcolumns 返回所选内容或区域中任何行的最大表格列数。
//wdmaximumnumberofrows 返回指定的所选内容或区域中表格的最大行数。
//wdnumberofpagesindocument 返回与所选内容或区域相关联的文档的页数。
//wdnumlock 如果 num lock 有效,则本参数返回 true。
//wdovertype 如果改写模式有效,则本参数返回 true。可用 overtype 属性改变改写模式的状态。
//wdreferenceoftype 返回一个值,该值表明所选内容相对于脚注、尾注或批注引用的位置,如下表所示。 值 描述
//— 1 所选内容或区域包含、但不只限定于脚注、尾注或批注引用中。
//0 所选内容或区域不在脚注、尾注或批注引用之前。
//1 所选内容或区域位于脚注引用之前。
//2 所选内容或区域位于尾注引用之前。
//3 所选内容或区域位于批注引用之前。
//wdrevisionmarking 如果修订功能处于活动状态,则本参数返回 true。
//wdselectionmode 返回一个值,该值表明当前的选定模式,如下表所示。 值 选定模式
//0 常规选定
//1 扩展选定
//2 列选定
//wdstartofrangecolumnnumber 返回所选内容或区域的起点所在的表格的列号。
//wdstartofrangerownumber 返回所选内容或区域的起点所在的表格的行号。
//wdverticalpositionrelativetopage 返回所选内容或区域的垂直位置,即所选内容的上边与页面的上边之间的距离,以磅为单位。如果所选内容或区域没有显示在屏幕上,则本参数返回 - 1。
//wdverticalpositionrelativetotextboundary 返回所选内容或区域相对于周围最近的正文边界的上边的垂直位置,以磅为单位。如果所选内容或区域没有显示在屏幕上,则本参数返回 - 1。
//wdwithintable 如果所选内容位于一个表格中,则本参数返回 true。
//wdzoompercentage 返回由 percentage 属性设置的当前的放大百分比。